﻿//
// ConsoleCSharp
//
// Copyright (c) 2016 http://www.curict.com
// This software is released under the MIT License, see LICENSE.txt.
//

using ConsoleCSharp;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using System.Collections.Generic;
namespace TestProject1
{


    /// <summary>
    ///FileUtilTest のテスト クラスです。すべての
    ///FileUtilTest 単体テストをここに含めます
    ///</summary>
    [TestClass()]
    public class FileUtilTest
    {


        private TestContext testContextInstance;

        /// <summary>
        ///現在のテストの実行についての情報および機能を
        ///提供するテスト コンテキストを取得または設定します。
        ///</summary>
        public TestContext TestContext
        {
            get
            {
                return testContextInstance;
            }
            set
            {
                testContextInstance = value;
            }
        }

        #region 追加のテスト属性
        //
        //テストを作成するときに、次の追加属性を使用することができます:
        //
        //クラスの最初のテストを実行する前にコードを実行するには、ClassInitialize を使用
        //[ClassInitialize()]
        //public static void MyClassInitialize(TestContext testContext)
        //{
        //}
        //
        //クラスのすべてのテストを実行した後にコードを実行するには、ClassCleanup を使用
        //[ClassCleanup()]
        //public static void MyClassCleanup()
        //{
        //}
        //
        //各テストを実行する前にコードを実行するには、TestInitialize を使用
        //[TestInitialize()]
        //public void MyTestInitialize()
        //{
        //}
        //
        //各テストを実行した後にコードを実行するには、TestCleanup を使用
        //[TestCleanup()]
        //public void MyTestCleanup()
        //{
        //}
        //
        #endregion


        /// <summary>
        ///IsSafePath のテスト
        ///</summary>
        [TestMethod()]
        public void IsSafePathTrueTest()
        {
            List<string> pathList = new List<string>();
            pathList.Add("c:\\");
            pathList.Add("c:\\test");
            pathList.Add("c:\\test\\");
            pathList.Add("c:\\test\\memo.txt");
            pathList.Add("c:\\test\\memo.txt\\");
            pathList.Add("c:\\test\\..\\test\\memo.txt");
            pathList.Add("c:\\test\\..\\test\\memo.txt\\");
            pathList.Add(".");
            pathList.Add(".\\");
            pathList.Add(".\\test");
            pathList.Add(".\\test\\");
            pathList.Add(".\\test\\memo.txt");
            pathList.Add(".\\test\\memo.txt\\");
            pathList.Add(".\\test\\..\\test\\memo.txt");
            pathList.Add(".\\test\\..\\test\\memo.txt\\");
            pathList.Add("..");
            pathList.Add("..\\");
            pathList.Add("..\\test");
            pathList.Add("..\\test\\");
            pathList.Add("..\\test\\memo.txt");
            pathList.Add("..\\test\\memo.txt\\");
            pathList.Add("..\\test\\..\\test\\memo.txt");
            pathList.Add("..\\test\\..\\test\\memo.txt\\");
            pathList.Add("\\\\networkPC\\");
            pathList.Add("\\\\networkPC\\test");
            pathList.Add("\\\\networkPC\\test\\");
            pathList.Add("\\\\networkPC\\test\\memo.txt");
            pathList.Add("\\\\networkPC\\test\\memo.txt\\");
            pathList.Add("\\\\networkPC\\test\\..\\test\\memo.txt");
            pathList.Add("\\\\networkPC\\test\\..\\test\\memo.txt\\");

            pathList.Add("COM");
            pathList.Add("COM");
            pathList.Add("aCOM");

            foreach (string path in pathList)
            {
                bool actual;
                actual = FileUtil.IsSafePath(path, false);
                Assert.IsTrue(actual, string.Format("引数:[{0}]", path));
            }
        }

        /// <summary>
        ///IsSafePath のテスト
        ///</summary>
        [TestMethod()]
        public void IsSafePathFalseTest()
        {
            List<string> pathList = new List<string>();
            pathList.Add(null);
            pathList.Add("");
            pathList.Add("CON");
            pathList.Add("PRN");
            pathList.Add("AUX");
            pathList.Add("NUL");
            pathList.Add("CLOCK$");
            pathList.Add("COM0");
            pathList.Add("COM1");
            pathList.Add("COM2");
            pathList.Add("COM3");
            pathList.Add("COM4");
            pathList.Add("COM5");
            pathList.Add("COM6");
            pathList.Add("COM7");
            pathList.Add("COM8");
            pathList.Add("COM9");
            pathList.Add("LPT0");
            pathList.Add("LPT1");
            pathList.Add("LPT2");
            pathList.Add("LPT3");
            pathList.Add("LPT4");
            pathList.Add("LPT5");
            pathList.Add("LPT6");
            pathList.Add("LPT7");
            pathList.Add("LPT8");
            pathList.Add("LPT9");

            pathList.Add(@".\CON");
            pathList.Add(@"CON\");
            pathList.Add(@".\CON\");

            pathList.Add(@".\CON.txt");
            pathList.Add(@"CON.txt\");
            pathList.Add(@".\CON.txt\");

            foreach (string path in pathList)
            {
                bool actual;
                actual = FileUtil.IsSafePath(path, false);
                Assert.IsFalse(actual, string.Format("引数:[{0}]", path));
            }
        }


        /// <summary>
        ///IsSafePath のテスト
        ///</summary>
        [TestMethod()]
        public void IsSafePath_Filename_TrueTest()
        {
            List<string> pathList = new List<string>();
            pathList.Add(".");
            pathList.Add("..");

            pathList.Add("COM");
            pathList.Add("COM");
            pathList.Add("aCOM");

            foreach (string path in pathList)
            {
                bool actual;
                actual = FileUtil.IsSafePath(path, true);
                Assert.IsTrue(actual, string.Format("引数:[{0}]", path));
            }
        }


        /// <summary>
        ///IsSafePath のテスト
        ///</summary>
        [TestMethod()]
        public void IsSafePath_Filename_FalseTest()
        {
            List<string> pathList = new List<string>();
            pathList.Add("c:\\");
            pathList.Add("c:\\test");
            pathList.Add("c:\\test\\");
            pathList.Add("c:\\test\\memo.txt");
            pathList.Add("c:\\test\\memo.txt\\");
            pathList.Add("c:\\test\\..\\test\\memo.txt");
            pathList.Add("c:\\test\\..\\test\\memo.txt\\");

            pathList.Add(".\\");
            pathList.Add(".\\test");
            pathList.Add(".\\test\\");
            pathList.Add(".\\test\\memo.txt");
            pathList.Add(".\\test\\memo.txt\\");
            pathList.Add(".\\test\\..\\test\\memo.txt");
            pathList.Add(".\\test\\..\\test\\memo.txt\\");

            pathList.Add("..\\");
            pathList.Add("..\\test");
            pathList.Add("..\\test\\");
            pathList.Add("..\\test\\memo.txt");
            pathList.Add("..\\test\\memo.txt\\");
            pathList.Add("..\\test\\..\\test\\memo.txt");
            pathList.Add("..\\test\\..\\test\\memo.txt\\");
            pathList.Add("\\\\networkPC\\");
            pathList.Add("\\\\networkPC\\test");
            pathList.Add("\\\\networkPC\\test\\");
            pathList.Add("\\\\networkPC\\test\\memo.txt");
            pathList.Add("\\\\networkPC\\test\\memo.txt\\");
            pathList.Add("\\\\networkPC\\test\\..\\test\\memo.txt");
            pathList.Add("\\\\networkPC\\test\\..\\test\\memo.txt\\");

            pathList.Add(null);
            pathList.Add("");
            pathList.Add("CON");
            pathList.Add("PRN");
            pathList.Add("AUX");
            pathList.Add("NUL");
            pathList.Add("CLOCK$");
            pathList.Add("COM0");
            pathList.Add("COM1");
            pathList.Add("COM2");
            pathList.Add("COM3");
            pathList.Add("COM4");
            pathList.Add("COM5");
            pathList.Add("COM6");
            pathList.Add("COM7");
            pathList.Add("COM8");
            pathList.Add("COM9");
            pathList.Add("LPT0");
            pathList.Add("LPT1");
            pathList.Add("LPT2");
            pathList.Add("LPT3");
            pathList.Add("LPT4");
            pathList.Add("LPT5");
            pathList.Add("LPT6");
            pathList.Add("LPT7");
            pathList.Add("LPT8");
            pathList.Add("LPT9");

            pathList.Add(@".\CON");
            pathList.Add(@"CON\");
            pathList.Add(@".\CON\");

            pathList.Add(@".\CON.txt");
            pathList.Add(@"CON.txt\");
            pathList.Add(@".\CON.txt\");


            foreach (string path in pathList)
            {
                bool actual;
                actual = FileUtil.IsSafePath(path, true);
                Assert.IsFalse(actual, string.Format("引数:[{0}]", path));
            }
        }
    }
}
